<?php
/*
Plugin Name: VoltRank Affiliate Plugin
Plugin URI: http://voltrank.com/script/wp
Description: Link Exchange Network.
Version: 1.2
Author: VoltRank
Author URI: http://voltrank.com
License: A "Slug" license name e.g. GPL2 *
*/

/*  Copyright 2010  VoltRank.com  (email : plugin@voltrank.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

if ( ! defined( 'WP_CONTENT_URL' ) )
      define( 'WP_CONTENT_URL', get_option( 'siteurl' ) . '/wp-content' );
if ( ! defined( 'WP_CONTENT_DIR' ) )
      define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ( ! defined( 'WP_PLUGIN_URL' ) )
      define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );
if ( ! defined( 'WP_PLUGIN_DIR' ) )
      define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins' );
if ( ! defined( 'VOLTRANK_NAME' ) )
	define( 'VOLTRANK_NAME', 'gubed6ceed5715a92c2232db69c9811a');

add_action( 'widgets_init', 'load_VoltRank_Widget' );

function load_VoltRank_Widget() {
	if ((defined('WP_ALLOW_MULTISITE') && WP_ALLOW_MULTISITE) || (function_exists('is_multisite') && is_multisite())) {
		if(function_exists('is_super_admin') && is_super_admin()) {
			add_action('admin_notices',  array('VoltRank_Widget', 'multisiteWarning'));
		}
	}
	return register_widget( 'VoltRank_Widget' );
}

class VoltRank_Widget extends WP_Widget {
	var $linker;

	public function multisiteWarning () {
		echo "<div id='sm-multisite-warning' class='error fade'><p><strong>".
		     __('VoltRank plugin is not multisite compatible.','gubed6ceed5715a92c2232db69c9811a')."</strong><br /> " .
			"</p></div>";
	}


	function VoltRank_Widget() {
		$fName = WP_PLUGIN_DIR . '/VoltRank/13a1c23ecc112934d595cfb.php';
		if (!is_readable($fName))
			$fName = dirname (__FILE__) . '/13a1c23ecc112934d595cfb.php';

		require_once ($fName);

		/*
		 * Pruner callback will be used to prune all cache from server when something changed.
		 * Pruning is not enabled by default.
		 *
		 * We will prune cache when:
		 *  - VoltrankDb::getEnableCachePrune returns true
		 *  - VoltrankDb::getPruneCache returns true
		 *
		 * setPruneCache (true) is triggered when getEnablePruneCache returns true and
		 *  - during successful incremental update
		 *  - during successful command fullUpdate
		 *
		 * Full update is triggered once for 72 hours and we want to do it less often.
		 * Incremental updates are triggered up to 2 hours depending on changes related to your website.
		 *
		 * We can do this actions manually but only for debugging purposes, that means we might refresh with intervals greater or equal to 2 hours.
		 */

		$this->linker = function_exists ('wp_cache_clear_cache')
				? new VoltRank (array ('pruner' => 'wp_cache_clear_cache'))
				: new VoltRank ();

		/**
		 * When running in test mode try to avoid being cached.
		 * This value is respected by two most popular plugins.
		 */
		if ($this->linker->__getTestMode ()) {
			define ('DONOTCACHEPAGE', true);
		}

		parent::WP_Widget(VOLTRANK_NAME, __('VoltRank', 'voltrank'));
	}


	function widget ($args, $instance) {
		extract ($args);

		echo $before_widget;
		echo $this->linker->display ();
		echo $after_widget;
	}


	function update( $new_instance, $old_instance ) {
		return $old_instance;
	}


	function form( $instance ) {
		if (($fp = @fopen (trailingslashit( dirname(__FILE__) ) . '/linker.err', 'r'))) {
			?>
			Error log not empty. Few last lines looks like this:<br>
			<?php
				$cnt = 0;
				$lines = array ();
				while (($line = fgets ($fp))) {
					$lines [$cnt++ % 10] = $line;
				}

				$limit = 10;
				while ($limit-- > 0 && ($line = @$lines[$cnt++ % 10]))
					echo $line . '<br>';
			return;
		}

		?>
		Everything works just fine.
		<?php

	}

}

?>
